---
title: Create a company
description: Learn how to create a company to centrally manage multiple organizations.
keywords: company, hub, organization, company owner, Admin Console, company management
aliases:
- /docker-hub/new-company/
---

{{< summary-bar feature_name="Company" >}}

You can create a new company in the Docker Admin Console. Before you begin, you must:
- Be the owner of the organization you want to add to your company
- Have a Docker Business subscription

{{% include "admin-early-access.md" %}}

## Create a company

To create a new company:

1. Sign in to the [Admin Console](https://app.docker.com/admin).
2. Select your organization you want to add to your company from the **Choose profile** page.
3. Under **Organization settings**, select **Company management**.
4. Select **Create a company**.
5. Enter a unique name for your company, then select **Continue**.

    > [!TIP]
    >
    > The name for your company can't be the same as an existing user, organization, or company namespace.

6. Review the company migration details and then select **Create company**.

For more information on how you can add organizations to your company, see [Add organizations to a company](./organizations.md#add-organizations-to-a-company).


## Next steps

- [Manage organizations](./organizations.md)
- [Manage company users](./users.md)
- [Manage company owners](./owners.md)

## More resources

- [Video: Create a company](https://youtu.be/XZ5_i6qiKho?feature=shared&t=359)
